import os

import socket, struct, fcntl

#/usr/include/linux/sockios.h
"""
#define SIOCGIFFLAGS    0x8913          /* get flags                    */
"""

#/usr/include/net/if.h
IFF_UP = 0x1 #,               /* Interface is up.  */
IFF_RUNNING = 0x40 #,         /* Resources allocated.  */

def run(ifname = "", **kw):
        try:
                iface = struct.pack('256s', ifname[:15]) 
                sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM) 
                info = fcntl.ioctl(sock.fileno(), 0x8913, iface) 
                flags = struct.unpack('h', info[16:18])[0]
                res = "Flags:"
                if not (flags & IFF_UP): raise RuntimeError("Device is down")
                if not (flags & IFF_RUNNING): raise RuntimeError("Device is not running")
                return (1, "Device is up and running")
        except Exception, e:
                return (0, str(e))

if __name__ == "__main__":
	print run( ifname = "eth0")
